﻿using System;

using Android.App;
using Android.Content.PM;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Xamarin.Forms;
using App6.Droid.Services;
using App6.Native;
using Android.Content;
using System.Reflection;
using Prism;
using Prism.Ioc;

namespace App6.Droid
{
    public class AgridentReceiver : BroadcastReceiver
    {
        public static String ACTION_AGRIDENT_SUCCESS = "fr.coppernic.intent.agridentsuccess";
        public static String ACTION_AGRIDENT_ERROR = "fr.coppernic.intent.agridentfailed";
        public static String KEY_BARCODE_DATA = "BarcodeData";
        public static String ACTION_AGRIDENT_SERVICE_STOP = "fr.coppernic.intent.action.stop.agrident.service";
        public static String ACTION_AGRIDENT_SERVICE_START = "fr.coppernic.intent.action.start.agrident.service";
        public static String ACTION_AGRIDENT_READ = "fr.coppernic.tools.agrident.wedge.READ";
        public override void OnReceive(Context context, Intent intent)
        {
            if (intent.Action.Equals(ACTION_AGRIDENT_SUCCESS))
            {
                // Data is available as a String
                String dataRead = intent.GetStringExtra(KEY_BARCODE_DATA);
            }
            else if (intent.Action.Equals(ACTION_AGRIDENT_ERROR))
            {
                // Read failed (main cause is timeout)
            }
        }
    }

    [Activity(Label = "App6", Icon = "@mipmap/icon", Theme = "@style/MainTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation | ConfigChanges.UiMode | ConfigChanges.ScreenLayout | ConfigChanges.SmallestScreenSize)]
    public class MainActivity : Xamarin.Forms.Platform.Android.FormsAppCompatActivity, IPlatformInitializer
    {
        public static MainActivity Instance { get; set; }

        public MainActivity()
        {
            //var renderers = Assembly.GetExecutingAssembly()
            //        .GetCustomAttributes(typeof(ExportRendererAttribute));
                    
            Instance = this;
        }

        public void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.Register<IBleService, DroidBleService>();
            containerRegistry.Register<INativeLibraryService, NativeLibraryService>();
        }

        protected override void OnCreate(Bundle savedInstanceState)
        {
            var receiver = new AgridentReceiver();

            IntentFilter intentFilter = new IntentFilter();
            intentFilter.AddAction(AgridentReceiver.ACTION_AGRIDENT_SUCCESS);
            intentFilter.AddAction(AgridentReceiver.ACTION_AGRIDENT_ERROR);
            RegisterReceiver(receiver, intentFilter);

            TabLayoutResource = Resource.Layout.Tabbar;
            ToolbarResource = Resource.Layout.Toolbar;

            base.OnCreate(savedInstanceState);

            Xamarin.Essentials.Platform.Init(this, savedInstanceState);
            global::Xamarin.Forms.Forms.Init(this, savedInstanceState);

            LoadApplication(new App(this));

        }
        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
        {
            Xamarin.Essentials.Platform.OnRequestPermissionsResult(requestCode, permissions, grantResults);

            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }

        public static String INTENT_ACTION_SCAN = "fr.coppernic.intent.action.SCAN";
        public static String INTENT_ACTION_STOP_SCAN = "fr.coppernic.intent.action.scan.STOP";
        public static String KEY_PACKAGE = "package";
        private static String AGRIDENT_WEDGE = "fr.coppernic.tools.cpcagridentwedge";


        internal void StartScan()
        {
            Intent launchIntent = PackageManager.GetLaunchIntentForPackage(AGRIDENT_WEDGE);
            if (launchIntent != null)
            {
                StartActivity(launchIntent);//null pointer check in case package name was not found
            }

        }
    }

}