﻿using App6.BLE;
using App6.Native;
using App6.Services;
using MyApp.IoC;
using Prism;
using Prism.DryIoc;
using Prism.Ioc;
using System;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace App6
{
    public partial class App : PrismApplication
    {
       
        public App(IPlatformInitializer initializer) : base(initializer) {
        }

        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {
            //DependencyService.Rgister<IMonService, MonService>();
            containerRegistry.Register<IMonService, MonService>();

            containerRegistry.RegisterForNavigation<NavigationPage>();
            containerRegistry.RegisterForNavigation<MainPage, MainViewModel>();
            containerRegistry.RegisterForNavigation<Page1, Page1ViewModel>();
            containerRegistry.RegisterForNavigation<BleTestView, BLETestViewModel>();

            var container = containerRegistry.GetContainer();
            DependencyResolver.SetInstance(new PrismDependencyResolver(container));
        }

        protected async override void OnInitialized()
        {
            InitializeComponent();
            await NavigationService.NavigateAsync("NavigationPage/BleTestView", null);
        }
    }
}
