﻿using Prism.Commands;
using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Input;
using Xamarin.Forms;

namespace App6
{
    public class CategoryViewModel : BindableBase
    {
        private List<ItemViewModel> _item;
        private ItemViewModel _selectedItem;

        public string Name { get; set; }

        public ICommand SelectCommand { get; private set; }


        public List<ItemViewModel> Items
        {
            get { return _item; }
            set { SetProperty(ref _item, value); }
        }

        public CategoryViewModel()
        {
            SelectCommand = new DelegateCommand<ItemViewModel>(SelectItem);
        }

        private void SelectItem(ItemViewModel item)
        {
            if (_selectedItem != null)
                _selectedItem.IsSelected = false;

            _selectedItem = item;

            if (_selectedItem != null)
                _selectedItem.IsSelected = true;
        }
    }
}
