﻿using MyApp.IoC;
using Prism.Commands;
using Prism.Mvvm;
using Prism.Navigation;
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Xamarin.Forms;

namespace App6
{
    public class MainViewModel : BindableBase, ILoadableViewModel
    {

        private bool _isBusy;
        public bool IsBusy
        {
            get { return _isBusy; }
            set { SetProperty(ref _isBusy, value); }
        }

        public ICommand ViewSummaryCommand { get; private set; }
        private List<CategoryViewModel> categories;
        public List<CategoryViewModel> Categories
        {
            get { return categories; }
            set { SetProperty(ref categories, value); }
        }

        public MainViewModel(INavigationService navigation)
        {
            IsBusy = true;
            ViewSummaryCommand = new DelegateCommand(async () =>
            {
                var parameters = new NavigationParameters();
                parameters.Add("categories", Categories);

                await navigation.NavigateAsync("../Page1", parameters);
            });
        }

        public async void Load()
        {
            IsBusy = true;

            var categories = await Task.Run(async () =>
            {
                var service = DependencyResolver.Get<IMonService>();
               return await service.GetCategories();
            });

            Categories = categories;
            IsBusy = false;
        }
    }
}
