﻿using Prism.Mvvm;
using Prism.Navigation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace App6
{
    public class Page1ViewModel : BindableBase, INavigationAware
    {
        private List<GroupItem> _items;

        public List<GroupItem> Items
        {
            get { return _items; }
            set { SetProperty(ref _items, value); }
        }

        public Page1ViewModel()
        {

        }

        public void OnNavigatedFrom(INavigationParameters parameters)
        {
        }

        public void OnNavigatedTo(INavigationParameters parameters)
        {
            var categories = (List<CategoryViewModel>)parameters["categories"];
            var items = new List<GroupItem>();
            foreach (var category in categories)
            {
                var groupItem = new GroupItem();
                groupItem.CategoryName = category.Name;

                var selectedItems = category.Items
                                            .Where(s => s.IsSelected)
                                            .ToList();

                groupItem.AddRange(selectedItems);
                items.Add(groupItem);
            }

            Items = items;
        }

        //public Page1ViewModel(List<CategoryViewModel> categories)
        //{
        //    var items = new List<GroupItem>();
        //    foreach (var category in categories)
        //    {
        //        var groupItem = new GroupItem();
        //        groupItem.CategoryName = category.Name;

        //        var selectedItems = category.Items
        //                                    .Where(s => s.IsSelected)
        //                                    .ToList();

        //        groupItem.AddRange(selectedItems);
        //        items.Add(groupItem);
        //    }

        //    Items = items;
        //}
    }
}
