﻿using System;
using System.Collections.Generic;
using System.Text;
using Xamarin.Forms;

namespace App6
{
    public class PageBase : ContentPage
    {
        private bool _once = false;

        protected override void OnAppearing()
        {
            var vm = BindingContext as ILoadableViewModel;
            if (vm != null &&
                _once == false)
            {
                _once = true;
                vm.Load();
            }

            base.OnAppearing();
        }

        protected override bool OnBackButtonPressed()
        {
            var vm = BindingContext as IBackable;
            if (vm != null)
                return vm.OnBackKeyPressed();

            return base.OnBackButtonPressed();
        }
    }
}
